/****************************************************************************\
*                                                                            *
* New World IV Source Copyright (c) James Ferry 2001                         *
* NWIV site - http://www.dukeworld.com/nw4/nwiv                              *
*                                                                            *
*                                                                            *
*                                                                            *
*                                                                            *
*                                                                            *
*                                                                            *
*                                                                            *
* Release 1                                                                  *
* The enemy AI is a bit dodgey.  The movement code is still the same as the  *
* original build engine (ie I haven't put my version in yet), so if a        *
* monster walks down a wall it will crash.                                   *
* I haven't commented anything in this thing, it is just as I use it.        *
*                                                                            *
* WEAPONS.H                                                                  *
* used in the game                                                           *
*                                                                            *
\****************************************************************************/

int load_weapon_data(void)
{
 weapon_image temp_image;
 weapon_stats temp_stats;
 sound_data   temp_sound;
 sound_set    temp_set;
 voxel_set    temp_vox;
 int voxnum=0;
 char temp_echo=1, temp_error=0, test1[256], test2[256], temp_mode=0;
 int temp_number=0;
 FILE *temp_in;
 printf("\n");
 if((temp_in=fopen("nwiv.ini","rb"))==NULL)
 return 1;
 while(!feof(temp_in)&&temp_error==0)
 {
  fgets(test1,256,temp_in);
if(!feof(temp_in))temp_error=1;
if(test1[0]==';')
 temp_error=0;
else
{
  switch(temp_mode)
  {

  case 6:
  if(sscanf(test1,"%i%*c%i%*c%i%*c%i%*c%i%*c%s",
   &temp_number,
   &temp_vox.cstat,
   &temp_vox.xrep,
   &temp_vox.yrep,
   &temp_vox.shade,
   &temp_vox.name)==6)
   {
    temp_vox.voxnum=-2;
    memcpy(&v_set[temp_number],&temp_vox,sizeof(voxel_set));
    temp_error=0;
   }
  break;

  case 5:
  if(sscanf(test1,"%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i",
   &temp_number,
   &temp_set.fire,
   &temp_set.lower,
   &temp_set.midlower,
   &temp_set.bottom,
   &temp_set.midbottom,
   &temp_set.raise,
   &temp_set.midraise,
   &temp_set.raised)==9)
   {
    memcpy(&s_set[temp_number],&temp_set,sizeof(sound_set));
    temp_error=0;
   }
   break;
  case 4:
  if(sscanf(test1,"%i%*c%li%*c%i%*c%li%*c%s",
   &temp_number,
   &temp_sound.freq,
   &temp_sound.var,
   &temp_sound.vol,
   &temp_sound.name[0])==5)
   {
    memcpy(&s_data[temp_number],&temp_sound,sizeof(sound_data));
    temp_error=0;
   }
  break;
  case 1:
  if(sscanf(test1,"%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%li",
   &temp_number,
   &temp_image.basex,
   &temp_image.basey,
   &temp_image.normal,
   &temp_image.fire,
   &temp_image.fire2,
   &temp_image.lower,
   &temp_image.bottom,
   &temp_image.raise,
   &temp_image.res)==10)
   {
    memcpy(&w_image[temp_number],&temp_image,sizeof(weapon_image));
    if(temp_echo)printf("\
image set: %i\n\t\
x, y;    (%i, %i)\n\t\
normal:  %i\n\t\
*fire 1: %i\n\t\
*fire 2: %i\n\t\
lower:   %i\n\t\
*bottom: %i\n\t\
raise:   %i\n\t\
res:     %li\n\n",
   temp_number,
   w_image[temp_number].basex,
   w_image[temp_number].basey,
   w_image[temp_number].normal,
   w_image[temp_number].fire,
   w_image[temp_number].fire2,
   w_image[temp_number].lower,
   w_image[temp_number].bottom,
   w_image[temp_number].raise,
   w_image[temp_number].res);
    temp_error=0;
    //getch();
   }
  break;
  case 3:
  if(sscanf(test1,"%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i%*c%i",
   &temp_number,
   &temp_stats.imageset,
   &temp_stats.clips,
   &temp_stats.clipsize,
   &temp_stats.rof,
   &temp_stats.rolt,
   &temp_stats.rort,
   &temp_stats.ror,
   &temp_stats.s1,
   &temp_stats.projectile)==10)
   {
memcpy(&w_stats[temp_number],&temp_stats,sizeof(weapon_stats));
    if(temp_echo)printf("\
weapon: %i\n\t\
image set;  %i\n\t\
clips;      %i\n\t\
clip size:  %i\n\t\
rof:        %i\n\t\
rolt:       %i\n\t\
rort:       %i\n\t\
ror:        %i\n\t\
sound 1:    %i\n\t\
projectile: %i\n\n",
   temp_number,
   w_stats[temp_number].imageset,
   w_stats[temp_number].clips,
   w_stats[temp_number].clipsize,
   w_stats[temp_number].rof,
   w_stats[temp_number].rolt,
   w_stats[temp_number].rort,
   w_stats[temp_number].ror,
   w_stats[temp_number].s1,
   w_stats[temp_number].projectile);
    temp_error=0;
    //getch();
   }
  break;


  }

  sscanf(test1,"%s",&test2);
  if(strcmpi("#exit",test2)==0)
  {
   fclose(temp_in);
   exit(1);
  }
       if(strcmpi("#images",test2)==0)      {temp_mode=1; temp_error=0;}
  else if(strcmpi("#projectiles",test2)==0) {temp_mode=2; temp_error=0;}
  else if(strcmpi("#weapons",test2)==0)     {temp_mode=3; temp_error=0;}
  else if(strcmpi("#sounds",test2)==0)      {temp_mode=4; temp_error=0;}
  else if(strcmpi("#soundsets",test2)==0)   {temp_mode=5; temp_error=0;}
  else if(strcmpi("#voxels",test2)==0)      {temp_mode=6; temp_error=0;}
  else if(strcmpi("#echo.",test2)==0)       {printf("\n");temp_error=0;}
  else if(strcmpi("#echo",test2)==0)
  {
   temp_error=0;
   sscanf(test1,"%*s%*c%s",&test2);
        if(strcmpi("on",test2)==0)  temp_echo=1;
   else if(strcmpi("off",test2)==0) temp_echo=0;
   else if(sscanf(test1,"%s%*c%s",&test2,&test2)==1)
    printf("Echo is %s.\n\n",temp_echo?"on":"on");
   else printf("%s",&test1[6]);
  }
  else if(strcmpi("#group",test2)==0)
  {
   if(sscanf(test1,"%*s%*c%s",&test2)==1)
   {
    sprintf(file_group,"%s",test2);
    temp_error=0;
   }
  }
  else if(strcmpi("#setup",test2)==0)
  {
   if(sscanf(test1,"%*s%*c%s",&test2)==1)
   {
    sprintf(file_setup,"%s",test2);
    temp_error=0;
   }
  }
  else if(strcmpi("#wave",test2)==0)
  {
   if(sscanf(test1,"%*s%*c%s",&test2)==1)
   {
    sprintf(file_wave,"%s",test2);
    temp_error=0;
   }
  }
  else if(strcmpi("#art",test2)==0)
  {
   if(sscanf(test1,"%*s%*c%s",&test2)==1)
   {
    sprintf(file_art,"%s",test2);
    temp_error=0;
   }
  }
  else if(strcmpi("#pause.",test2)==0)
  {
   temp_error=0;
   while(kbhit())getch();while(!kbhit());while(kbhit())getch();
  }
  else if(strcmpi("#pause",test2)==0)
  {
   temp_error=0;
   if(sscanf(test1,"%s%*c%s",&test2,&test2)==1)
    printf("Please press any key to continue.\n\n");
   else printf("%s",&test1[7]);
   while(kbhit())getch();while(!kbhit());while(kbhit())getch();
  }

  if(temp_error!=0&&sscanf(test1,"%s",&test2)==-1)
    temp_error=0;
}
 }
 fclose(temp_in);
 if(temp_error!=0){printf("Error occured whilst reading file.\n");exit(1);}
 return 1;
}
